var that = this;
function __skpm_run (key, context) {
  that.context = context;

var exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/export-to-sparkle.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/export-to-sparkle.js":
/*!**********************************!*\
  !*** ./src/export-to-sparkle.js ***!
  \**********************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! sketch */ "sketch");
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(sketch__WEBPACK_IMPORTED_MODULE_0__);
 // documentation: https://developer.sketchapp.com/reference/api/

var doc = null;
var textStyles = null;
var version = null;
/* harmony default export */ __webpack_exports__["default"] = (function (context) {
  version = NSBundle.mainBundle().infoDictionary()["CFBundleShortVersionString"].integerValue();
  var selectedLayers = context.selection;
  var selectedCount = selectedLayers.length;
  doc = context.document;
  var hasArtboards = false;
  var elements = NSMutableArray.alloc().init();
  var exportedArtboards = NSMutableArray.alloc().init();
  selectedLayers.forEach(function (layer) {
    var artboard = null;

    if (layer.class() == MSArtboardGroup) {
      artboard = layer;
    } else {
      artboard = layer.parentArtboard();

      if (artboard != null && exportedArtboards.containsObject(artboard)) {
        artboard = null;
      }
    }

    if (artboard != null) {
      exportedArtboards.addObject(artboard);
      export_artboard(artboard, elements);
      hasArtboards = true;
    }
  });

  if (elements.count() > 0) {
    var jsonData = NSJSONSerialization.dataWithJSONObject_options_error_(elements, 0, null);
    var jsonString = NSString.alloc().initWithData_encoding_(jsonData, NSUTF8StringEncoding);
    var clipboard = NSPasteboard.generalPasteboard();
    clipboard.declareTypes_owner([NSPasteboardTypeString, "eu.riverdesign.sparkle.sketch.items"], null);
    clipboard.setString_forType(jsonString, "eu.riverdesign.sparkle.sketch.items"); //        jsonData = NSJSONSerialization.dataWithJSONObject_options_error_(elements, 1, null)
    //        jsonString = NSString.alloc().initWithData_encoding_(jsonData,NSUTF8StringEncoding)
    //        clipboard.setString_forType(jsonString, NSPasteboardTypeString)

    textMsg = "Open Sparkle on a new (or existing) document and paste with ⌘-V";
  } else if (!hasArtboards) {
    textMsg = "Select the artboard(s) you want to export";
  } else {
    textMsg = "Export failed";
  }

  sketch__WEBPACK_IMPORTED_MODULE_0___default.a.UI.message(textMsg);
});
var textMsg = '';

function export_artboard(artboard, elements) {
  var element = null;
  var children = export_children(artboard);

  if (children.count() > 0) {
    element = NSMutableDictionary.alloc().init();
    element.setObject_forKey_(artboard.name(), "name");
    element.setObject_forKey_("artboard", "type");
    var frame = artboard.frame();
    element.setObject_forKey_(frame.width(), "w");
    element.setObject_forKey_(frame.height(), "h");

    if (artboard.hasBackgroundColor()) {
      element.setObject_forKey_(rgba_from_color(artboard.backgroundColor()), "backgroundColor");
    }

    element.setObject_forKey_(children, "children");
    elements.addObject(element);

    if (textStyles != null && textStyles.count() > 0) {
      element.setObject_forKey_(textStyles, "textStyles");
    }
  }

  return element;
}

function export_layer(layer, elements) {
  var element = null;

  if (layer.class() == MSRectangleShape) {
    element = export_rectangle(layer, elements);
  } else if (layer.class() == MSBitmapLayer) {
    if (should_export_layer_as_rectangle(layer)) {
      element = export_as_rectangle(layer, "png", elements);
    } else if (should_export_image_as_png(layer)) {
      element = export_as_image(layer, "png", elements);
    } else {
      element = export_image(layer, elements);
    }
  } else if (layer.class() == MSTextLayer) {
    element = export_text(layer, elements);
  } else if (layer.isKindOfClass(MSShapePathLayer) || layer.class() == MSShapeGroup) {
    element = export_as_image(layer, should_export_layer_as_png(layer) ? "png" : "svg", elements);
  } else if (layer.class() == MSLayerGroup) {
    element = export_group(layer, elements);
  } else if (layer.class() == MSSymbolInstance) {
    var symbol = layer.duplicate();
    var group = version >= 76 ? symbol.detachStylesAndReplaceWithGroup() : symbol.detachStylesAndReplaceWithGroupRecursively(true);
    element = export_group(group, elements);
    group.removeFromParent();
  } else {
    textMsg += '[' + layer.class() + '] ';
  }

  if (element != null) {
    textMsg += layer.name() + ' ';
  }

  return element;
}

function export_rectangle(rectangle, elements) {
  return export_as_rectangle(rectangle, null, elements);
}

function export_as_rectangle(layer, format, elements) {
  var element = NSMutableDictionary.alloc().init();
  element.setObject_forKey_(layer.name(), "name");
  element.setObject_forKey_("box", "type");
  var frame;
  var fill;

  if (format != null || should_export_rectangle_as_image(layer)) {
    var parentFrame = clipped_frame_for_layer(layer.parentGroup());
    if (!parentFrame) return null;
    var rotation = 0;
    frame = frame_for_layer(layer);
    if (!CGRectIntersectsRect(parentFrame, frame)) return null;else if (!CGRectContainsRect(parentFrame, frame)) {
      frame = CGRectIntersection(parentFrame, frame);
    } else {
      rotation = layer.rotation();

      if (rotation != 0) {
        layer.setRotation(0);
        frame = frame_for_layer(layer);
      }
    }
    set_frame_for_element(frame, parentFrame, element);
    var imageData;

    if (format == "png" || format == null && should_export_layer_as_png(layer)) {
      imageData = image_data_for_layer(layer, frame, format = "png");
    } else {
      imageData = image_data_for_layer(layer, frame, format = "svg");
    }

    fill = NSMutableDictionary.alloc().init();
    fill.setObject_forKey_("image", "type");
    fill.setObject_forKey_(imageData, "imageData");
    fill.setObject_forKey_("2", "filltype");
    fill.setObject_forKey_("1", "scale");

    if (rotation != 0) {
      element.setObject_forKey_(rotation, "rotation");
      layer.setRotation(rotation);
    }
  } else {
    frame = add_frame_to_element(layer, element);

    if (!frame) {
      return null;
    }

    fill = get_fill_info(layer);
  }

  if (fill != null) {
    element.setObject_forKey_(fill, "fill");
  }

  var artboardRect = layer.parentArtboard().rect();

  if (frame.size.width == artboardRect.size.width) {
    element.setObject_forKey_("1", "wide");
  } //    textMsg += "**" + format + "** "


  if (format == null) {
    if (layer.class() != MSLayerGroup) {
      var rounding = layer.cornerRadiusFloat();
      element.setObject_forKey_(rounding, "rounding");
    }

    var border = get_border_info(layer);

    if (border != null) {
      element.setObject_forKey_(border, "border");
    }

    var shadow = get_shadow_info(layer);

    if (shadow != null) {
      element.setObject_forKey_(shadow, "shadow");
    }

    var opacity = get_opacity_info(layer);

    if (opacity != null) {
      element.setObject_forKey_(opacity, "opacity");
    }
  }

  elements.addObject(element);
  return element;
}

function image_data_for_layer(layer, frame, format) {
  var ancestry;
  var ancestryClass = NSClassFromString("SketchModel.MSImmutableLayerAncestry");

  if (ancestryClass != null) {
    ancestry = _TtC11SketchModel24MSImmutableLayerAncestry.alloc().initWithMutableLayer_(layer);
  } else {
    ancestry = MSImmutableLayerAncestry.ancestryWithMSLayer_(layer);
  }

  var exportRequest = MSExportRequest.exportRequestsFromLayerAncestry_(ancestry).firstObject();
  exportRequest.format = format;
  exportRequest.shouldTrim = false;
  exportRequest.rect = frame;
  exportRequest.scale = format == "png" ? 2 : 1;
  exportRequest.includeArtboardBackground = false;
  var colorspace = NSColorSpace.sRGBColorSpace();
  var exporter = MSExporter.exporterForRequest_colorSpace_(exportRequest, version >= 86 ? colorspace.CGColorSpace() : colorspace);
  var imageData;

  if (format == "png") {
    imageData = exporter.data().base64EncodedStringWithOptions(0);
  } else {
    //        var frame = layer.frame()
    //        var svgExporter = SketchSVGExporter.alloc().init()
    //        var svgData = svgExporter.exportLayers([layer.immutableModelObject()])
    //        var svgString = NSString.alloc().initWithData_encoding(svgData, NSUTF8StringEncoding)
    //        svgString = svgString.replace(/(\r\n|\n|\r)<svg[^>]*>/g, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg width=\""+frame.width()+"px\" height=\""+frame.height()+"px\" viewBox=\"0 0 "+frame.width()+" "+frame.height()+"\" version=\"1.1\" xmlns=\"http:\/\/www.w3.org\/2000\/svg\" xmlns:xlink=\"http:\/\/www.w3.org\/1999\/xlink\">")
    //        /* svgString = svgString.replace(/ transform=\"translate\([0-9.,\s]+\)\"/g, "") */
    //        element.setObject_forKey_(svgString, "imageData")
    imageData = NSString.alloc().initWithData_encoding(exporter.data(), NSUTF8StringEncoding);
  }

  return imageData;
}

function export_as_image(layer, format, elements) {
  var element = NSMutableDictionary.alloc().init();
  var rotation = 0;
  var parentFrame = clipped_frame_for_layer(layer.parentGroup());
  if (!parentFrame) return null;
  var frame = frame_for_layer(layer);
  if (!CGRectIntersectsRect(parentFrame, frame)) return null;else if (!CGRectContainsRect(parentFrame, frame)) {
    frame = CGRectIntersection(parentFrame, frame);
  } else {
    rotation = layer.rotation();

    if (rotation != 0) {
      layer.setRotation(0);
      frame = frame_for_layer(layer);
    }
  }
  set_frame_for_element(frame, parentFrame, element);
  var name = layer.name();
  var suffix = "." + format;
  if (!name.endsWith(suffix)) name += suffix;
  element.setObject_forKey_(name, "name");
  element.setObject_forKey_(format, "type");
  var imageData = image_data_for_layer(layer, frame, format);
  element.setObject_forKey_(imageData, "imageData");
  var opacity = get_opacity_info(layer);

  if (opacity != null) {
    element.setObject_forKey_(opacity, "opacity");
  }

  if (rotation != 0) {
    element.setObject_forKey_(rotation, "rotation");
    layer.setRotation(rotation);
  }

  elements.addObject(element);
  return element;
}

function export_image(image, elements) {
  var element = NSMutableDictionary.alloc().init();
  element.setObject_forKey_(image.name(), "name");
  element.setObject_forKey_("image", "type");
  if (!add_frame_to_element(image, element)) return null;
  /*
      var exportRequest = MSExportRequest.exportRequestsFromExportableLayer(image).firstObject()
      if(exportRequest != null) {
          var format = exportRequest.format()
          var exporter = MSExporter.exporterForRequest_colorSpace(exportRequest, NSColorSpace.sRGBColorSpace())
          var imageData = exporter.data()
          var base64Code = imageData.base64EncodedStringWithOptions(0)
          element.setObject_forKey_(format, "format")
          element.setObject_forKey_(base64Code, "imageData")
      }
  */

  element.setObject_forKey_(image.image().data().base64EncodedStringWithOptions(0), "imageData");
  var border = get_border_info(image);

  if (border != null) {
    element.setObject_forKey_(border, "border");
  }

  var shadow = get_shadow_info(image);

  if (shadow != null) {
    element.setObject_forKey_(shadow, "shadow");
  }

  var opacity = get_opacity_info(image);

  if (opacity != null) {
    element.setObject_forKey_(opacity, "opacity");
  }

  elements.addObject(element);
  return element;
}

function export_text(text, elements) {
  var element = NSMutableDictionary.alloc().init();
  element.setObject_forKey_(text.name(), "name");
  element.setObject_forKey_("text", "type");
  element.setObject_forKey_(text.attributedString().treeAsDictionary(), "text"); //    var attributedString = text.attributedStringValue()
  //    element.setObject_forKey_(attributedString.RTFDFromRange_documentAttributes_(NSMakeRange(0, attributedString.length()), null).base64EncodedStringWithOptions(0), "text")

  if (!add_frame_to_element(text, element)) return null;
  var shadow = get_shadow_info(text);

  if (shadow != null) {
    element.setObject_forKey_(shadow, "shadow");
  }

  var opacity = get_opacity_info(text);

  if (opacity != null) {
    element.setObject_forKey_(opacity, "opacity");
  }

  var textStyle = text.style().textStyle();

  if (textStyle != null) {
    var style = NSMutableDictionary.alloc().init();
    var textSharedStyle = find_text_style_with_id(text.sharedStyleID());

    if (textSharedStyle != null) {
      var textStyleName = textSharedStyle.name();

      if (textStyles == null) {
        textStyles = NSMutableDictionary.alloc().init();
      }

      if (textStyles.objectForKey_(textStyleName) == null) {
        //                textStyles.setObject_forKey_(get_text_style(textStyle), textStyleName)
        textStyles.setObject_forKey_(get_text_style(textSharedStyle.value().textStyle()), textStyleName);
      }

      element.setObject_forKey_(textSharedStyle.name(), "textStyle");
    }
  }

  elements.addObject(element);
  return element;
}

function get_text_style(textStyle) {
  return textStyle.attributes().treeAsDictionary();
}

function find_text_style_with_id(styleID) {
  return doc.documentData().layerTextStyles().sharedStyleWithID(styleID);
}

function export_group(group, elements) {
  var image_format = false;

  if (group.rotation() != 0) {
    var artboardRect = group.parentArtboard().rect();
    var frameRect = frame_for_layer(group);

    if (!CGRectContainsRect(artboardRect, frameRect)) {
      image_format = should_export_group_as_image(group);

      if (image_format == false) {
        image_format = "png";
      }
    }
  }

  var element = null;

  if (image_format == false) {
    image_format = should_export_group_as_image(group);
  } //    textMsg += image_format + " "


  if (image_format == false) {
    var children = export_children(group);

    if (children.count() > 0) {
      element = NSMutableDictionary.alloc().init();
      var parentFrame = clipped_frame_for_layer(group.parentGroup());
      if (!parentFrame) return null;
      var frame = frame_for_layer(group);
      if (!CGRectIntersectsRect(parentFrame, frame)) return null;else if (!CGRectContainsRect(parentFrame, frame)) {
        frame = CGRectIntersection(parentFrame, frame);
      } else {
        var rotation = group.rotation();

        if (rotation != 0) {
          group.setRotation(0);
          frame = frame_for_layer(group);
          element.setObject_forKey_(rotation, "rotation");
          group.setRotation(rotation);
        }
      }
      set_frame_for_element(frame, parentFrame, element);
      element.setObject_forKey_(group.name(), "name");
      element.setObject_forKey_("group", "type");
      element.setObject_forKey_(children, "children");
      elements.addObject(element);
    }
  } else if (should_export_layer_as_rectangle(group)) {
    element = export_as_rectangle(group, image_format, elements);
  } else {
    element = export_as_image(group, image_format, elements);
  }

  return element;
}

function should_export_layer_as_rectangle(layer) {
  var frame = clipped_frame_for_layer(layer);
  if (!frame) return false;
  var artboardRect = layer.parentArtboard().rect();

  if (frame.size.width == artboardRect.size.width && layer.rotation() == 0) {
    return true;
  }

  return false;
}

function should_export_layer_as_png(layer) {
  var isRectangleShape = layer.class() == MSRectangleShape;
  var fill = get_fill_info(layer);

  if (fill != null) {
    if (fill.isKindOfClass(NSArray)) {
      for (var i = 0; i < fill.count(); i++) {
        var fillItem = fill.objectAtIndex(i); //                textMsg += fillItem.objectForKey_("type") + " - " + fillItem.objectForKey_("gradientType") + " "

        if (fillItem.objectForKey_("type") == "image") {
          //                    textMsg += "1@ "
          return true;
        } else if (fillItem.objectForKey_("type") == "gradient") {
          if (isRectangleShape && fillItem.objectForKey_("gradientType") != "linear") {
            //                        textMsg += "2@ "
            return true;
          } else if (!isRectangleShape && (fillItem.objectForKey_("gradientType") == "angular" || fillItem.objectForKey_("gradientType") == "unknown")) {
            //                        textMsg += "3@ "
            return true;
          }
        }
      }
    } else {
      //            textMsg += fill.objectForKey_("type") + " - " + fill.objectForKey_("gradientType") + " "
      if (fill.objectForKey_("type") == "image") {
        //                textMsg += "4@ "
        return true;
      } else if (fill.objectForKey_("type") == "gradient") {
        if (isRectangleShape && fill.objectForKey_("gradientType") != "linear") {
          //                    textMsg += "5@ "
          return true;
        } else if (!isRectangleShape && (fill.objectForKey_("gradientType") == "angular" || fill.objectForKey_("gradientType") == "unknown")) {
          //                    textMsg += "6@ "
          return true;
        }
      }
    }
  }

  return false;
}

function should_export_group_as_image(group) {
  if (group.layers().count() <= 1 && group.parentGroup() == group.parentArtboard() && group.closestClippingLayer() == null) return false;
  var format = "svg";
  var hasGroup = false;
  var hasShapes = false;
  var hasImages = false;
  group.layers().forEach(function (layer) {
    if (format != false) {
      if (layer.class() == MSLayerGroup || layer.class() == MSShapeGroup) {
        if (layer.layers().count()) {
          var group_format = should_export_group_as_image(layer);

          if (group_format != "svg") {
            format = group_format;
          }
        }

        hasGroup = true;
      } else if (layer.class() == MSRectangleShape || layer.isKindOfClass(MSShapePathLayer)) {
        if (should_export_layer_as_png(layer)) {
          format = "png";
          hasImages = true;
        } else {
          hasShapes = true;
        }
      } else if (layer.class() == MSBitmapLayer) {
        format = "png";
        hasImages = true;
      } else if (layer.class() == MSSymbolInstance) {
        var symbol = layer.duplicate();
        var group = version >= 76 ? symbol.detachStylesAndReplaceWithGroup() : symbol.detachStylesAndReplaceWithGroupRecursively(true);
        var group_format = should_export_group_as_image(group);

        if (group_format != "svg") {
          format = group_format;
        }

        group.removeFromParent();
        hasGroup = true;
      } else if (layer.class() == MSTextLayer) {
        format = false;
      } //            if(format == "svg") {
      //                if(layer.hasClippingMask()) {
      //                    format = "png"
      //                }
      //            }

    }
  });

  if (!hasGroup && !hasShapes && !hasImages) {
    format = false;
  } //    if(format == "svg") {
  //        if(group.closestClippingLayer() != null) {
  //            format = "png"
  //        }
  //    }


  return format;
}

function should_export_rectangle_as_image(rectangle) {
  if (!rectangle.isRectangle()) {
    //        textMsg += "1* "
    return true;
  }

  var blur = rectangle.style().blur();

  if (blur != null && blur.isEnabled()) {
    //        textMsg += "2* "
    return true;
  }

  var fill = get_fill_info(rectangle);

  if (fill != null) {
    if (fill.isKindOfClass(NSArray)) {
      //            textMsg += "3* "
      return true;
    } else if (fill.objectForKey_("type") == "gradient" && fill.objectForKey_("gradientType") != "linear") {
      //            textMsg += "3a* "
      return true;
    }
  }

  var artboardRect = rectangle.parentArtboard().rect();
  var frameRect = frame_for_layer(rectangle);

  if (!CGRectContainsRect(artboardRect, frameRect)) {
    //        textMsg += NSStringFromRect(artboardRect) + " " + NSStringFromRect(frameRect) + " "
    if (fill != null) {
      //            textMsg += fill.objectForKey_("type") + " " + fill.objectForKey_("filltype") + " "
      if (fill.objectForKey_("type") == "image" && fill.objectForKey_("filltype") != "0") {
        //                textMsg += "4* "
        return true;
      } else if (fill.objectForKey_("type") == "gradient") {
        //                textMsg += "5* "
        return true;
      }
    }
  }

  return false;
}

function should_export_image_as_png(image) {
  var blur = image.style().blur();

  if (blur != null && blur.isEnabled()) {
    //        textMsg += "1§ "
    return true;
  }

  var fill = get_fill_info(image);

  if (fill != null) {
    //        textMsg += "2§ "
    return true;
  }

  var artboardRect = image.parentArtboard().rect();
  var frameRect = frame_for_layer(image);

  if (CGRectIntersectsRect(frameRect, artboardRect)) {
    frameRect = CGRectIntersection(frameRect, artboardRect);
    var frame = image.frame();

    if (frame.width() != frameRect.size.width || frame.height() != frameRect.size.height) {
      //            textMsg += "3§ "
      return true;
    }
  }

  if (image.hasClippingMask()) {
    if (image.closestClippingLayer() != null && CGRectContainsRect(frame_for_layer(image.closestClippingLayer()), frame_for_layer(image))) {
      return false;
    } //        textMsg += "4§ "


    return true;
  }

  return false;
}

function export_children(layer) {
  var children = NSMutableArray.alloc().init();
  layer.layers().forEach(function (layer) {
    if (layer.isVisible()) {
      textMsg += layer.class() + ' ';
      export_layer(layer, children);
    }
  });
  return children;
}

function frame_for_layer(layer) {
  if (layer.class() == MSArtboardGroup) {
    var frame = layer.frame().rect();
    return frame;
  }

  var frame = layer.frame().rect();

  if (layer.parentGroup() != null) {
    var parentFrame = frame_for_layer(layer.parentGroup());
    frame.origin.x += parentFrame.origin.x;
    frame.origin.y += parentFrame.origin.y;
  }

  return frame;
}

function clipped_frame_for_layer(layer) {
  if (layer.class() == MSArtboardGroup) {
    return frame_for_layer(layer);
  }

  var frame = frame_for_layer(layer);

  if (layer.parentGroup() != null) {
    var parentFrame = clipped_frame_for_layer(layer.parentGroup());
    if (!parentFrame || !CGRectIntersectsRect(parentFrame, frame)) return false;
    frame = CGRectIntersection(parentFrame, frame);
  }

  return frame;
}

function add_frame_to_element(layer, element) {
  var parentFrame = clipped_frame_for_layer(layer.parentGroup());
  if (!parentFrame) return false;
  var frame = frame_for_layer(layer);
  if (!CGRectIntersectsRect(parentFrame, frame)) return false;
  var rotation = layer.rotation();

  if (rotation != 0) {
    element.setObject_forKey_(rotation, "rotation");
  } else {
    frame = CGRectIntersection(parentFrame, frame);
  }

  set_frame_for_element(frame, parentFrame, element);
  return frame;
}

function set_frame_for_element(frame, parentFrame, element) {
  element.setObject_forKey_(frame.origin.x - parentFrame.origin.x, "x");
  element.setObject_forKey_(frame.origin.y - parentFrame.origin.y, "y");
  element.setObject_forKey_(frame.size.width, "w");
  element.setObject_forKey_(frame.size.height, "h");
}

function get_fill_info(layer) {
  var elements = NSMutableArray.alloc().init();
  var fills = layer.style().fills();

  if (fills != null) {
    fills.slice().reverse().forEach(function (fill) {
      if (fill.isEnabled()) {
        var fillType = fill.fillType();

        if (fillType == 0 || fillType == 1 || fillType == 4) {
          var element = NSMutableDictionary.alloc().init();

          if (fillType == 0) {
            element.setObject_forKey_("color", "type");
            element.setObject_forKey_(rgba_from_color(fill.color()), "color");
          } else if (fillType == 1) {
            element.setObject_forKey_("gradient", "type");
            var gradient = fill.gradient();

            if (gradient.gradientType() == 0) {
              element.setObject_forKey_("linear", "gradientType");
              var gradient1 = gradient.stops().objectAtIndex(0).color();
              element.setObject_forKey_(rgba_from_color(gradient1), "color");
              var gradient2 = gradient.stops().objectAtIndex(1).color();
              element.setObject_forKey_(rgba_from_color(gradient2), "color2");
              var angle = Math.atan2(gradient.to().y - gradient.from().y, gradient.to().x - gradient.from().x);
              element.setObject_forKey_(angle, "angle");
            } else if (gradient.gradientType() == 1) {
              element.setObject_forKey_("radial", "gradientType");
            } else if (gradient.gradientType() == 2) {
              element.setObject_forKey_("angular", "gradientType");
            } else {
              element.setObject_forKey_("unknown", "gradientType");
            }
          } else if (fillType == 4) {
            element.setObject_forKey_("image", "type");
            element.setObject_forKey_(fill.image().data().base64EncodedStringWithOptions(0), "imageData");
            element.setObject_forKey_(fill.patternFillType(), "filltype");
            element.setObject_forKey_(fill.patternTileScale(), "scale");
          } // can't retrieve fill's opacity, is not exposed
          // element.setObject_forKey_(fill.opacity(), "opacity")


          elements.addObject(element);
        }
      }
    });
  }

  return elements.count() > 1 ? elements : elements.firstObject();
}

function get_border_info(layer) {
  var element = null;
  var borders = layer.style().borders();

  if (borders != null) {
    borders.slice().reverse().forEach(function (border) {
      if (element == null && border.isEnabled()) {
        element = NSMutableDictionary.alloc().init();
        element.setObject_forKey_(border.thickness(), "width");
        element.setObject_forKey_(border.position(), "position");
        element.setObject_forKey_(rgba_from_color(border.color()), "color");
      }
    });
  }

  return element;
}

function get_shadow_info(layer) {
  var element = null;
  var shadows = layer.style().shadows();

  if (shadows != null) {
    shadows.slice().reverse().forEach(function (shadow) {
      if (element == null && shadow.isEnabled()) {
        element = NSMutableDictionary.alloc().init();
        element.setObject_forKey_(shadow.blurRadius(), "blur");
        element.setObject_forKey_(shadow.offsetX(), "x");
        element.setObject_forKey_(shadow.offsetY(), "y");
        element.setObject_forKey_(shadow.spread(), "spread");
        element.setObject_forKey_(rgba_from_color(shadow.color()), "color");
      }
    });
  }

  return element;
}

function get_opacity_info(layer) {
  var opacity = layer.style().contextSettings().opacity();

  if (opacity != null) {
    return opacity;
  }

  return null;
}

function rgba_from_color(color) {
  var colorObj = color.immutableModelObject();
  return "rgba(" + parseInt(colorObj.red() * 255) + "," + parseInt(colorObj.green() * 255) + "," + parseInt(colorObj.blue() * 255) + "," + parseInt(colorObj.alpha() * 100) / 100 + ")";
}

/***/ }),

/***/ "sketch":
/*!*************************!*\
  !*** external "sketch" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("sketch");

/***/ })

/******/ });
  if (key === 'default' && typeof exports === 'function') {
    exports(context);
  } else {
    exports[key](context);
  }
}
that['onRun'] = __skpm_run.bind(this, 'default')

//# sourceMappingURL=export-to-sparkle.js.map